﻿#region Using directives

using System;
using System.Collections;
using System.Text;
using System.Reflection;

#endregion

namespace MiMFa.Libraries.AOPLibrary
{
    public class AOPConfig
    {
				// <Type, AOPControllerInfo>
        private static Hashtable associations = new Hashtable();

        public static bool Enabled = true;

        public static void SetAssoc(Type classtype, Type controllertype, IMessageMatcher matcher)
        {
            ConstructorInfo ci = controllertype.GetConstructor(Type.EmptyTypes);
            AOPBaseController controller = (AOPBaseController)ci.Invoke(null);
            associations[classtype] = new AOPControllerInfo(controller, matcher);
        }

        public static AOPControllerInfo GetAssoc(Type classtype)
        {
            return (AOPControllerInfo)associations[classtype];
        }
    }
}
