﻿#region Using directives

using System.Runtime.Remoting.Messaging;

#endregion

namespace MiMFa.Libraries.AOPLibrary
{
    public class AOPBaseController
    {
        public virtual void Begin(object o, IMessage msg) {}
        
        public virtual void End(object o, IMessage msg) {}
        
        public virtual IMessage SyncProcessMessage(object o, IMessageSink sink, IMessage msg)
        {
            Begin(o, msg);
            IMethodReturnMessage returnedMessage = (IMethodReturnMessage)sink.SyncProcessMessage(msg);
            if (returnedMessage.Exception != null)
                End(o, msg);
            return returnedMessage;
        }
    }
}
