﻿#region Using directives

using System;
using System.Runtime.Remoting.Contexts;
using System.Runtime.Remoting.Activation;

#endregion

namespace MiMFa.Libraries.AOPLibrary
{
    [AttributeUsage(AttributeTargets.Class)]
    public class AOPAttribute : ContextAttribute
    {
        public AOPAttribute() : base("AOPAttribute") {}

        public override void GetPropertiesForNewContext(IConstructionCallMessage ctor)
        {
            if (AOPConfig.Enabled)
                ctor.ContextProperties.Add(new AOPProperty());
        }

        public override bool IsContextOK(Context ctx, IConstructionCallMessage ctorMsg)
        {return false;}
    }
}
