﻿#region Using directives

using System;
using System.Runtime.Remoting.Messaging;
using System.Runtime.Remoting;

#endregion

namespace FrogSoftware.Libraries.AOPLibrary
{
    public class AOPSink : IMessageSink
    {
        private IMessageSink m_NextSink;
        private ObjRef realobject = null;

        public AOPSink(IMessageSink nextSink)
        {this.m_NextSink = nextSink;}

        public IMessageSink NextSink {get {return m_NextSink;}}

        public IMessage SyncProcessMessage(IMessage msg)
        {
						IMethodMessage methodMessage = (IMethodMessage)msg;

            if (methodMessage.MethodName == ".ctor")
            {
                IMethodReturnMessage ret = (IMethodReturnMessage)m_NextSink.SyncProcessMessage(msg);
                realobject = (ObjRef)ret.ReturnValue;
                return ret;
            }
            else
            {
                AOPBaseClass obj = (AOPBaseClass)RemotingServices.Unmarshal(realobject);
                return obj.SyncProcessMessage(m_NextSink, msg);
            }
        }

        public IMessageCtrl AsyncProcessMessage(IMessage msg, IMessageSink replySink)
        {
            throw new NotSupportedException();
        }
    }
}
