using System;
using System.Windows.Forms;
using MiMFa.Libraries.AOPLibrary;

namespace TestAOP
{
	public class Program
	{
		[STAThread]
		static void Main() 
		{
			//AOPConfig.Enabled = false;
			AOPConfig.SetAssoc(typeof(TestClass), typeof(TestClassController), new RegExMethNameMatcher());

			TestClass t1 = new TestClass();
			t1.Test1();

			int start = Environment.TickCount;

			for (int i = 0; i < 100000; i++)
				t1.Test1();

			int end = Environment.TickCount;
      
			MessageBox.Show("Total time: " + (end - start).ToString());
		}
	}
}
