﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Bank.Aspects.Proxy;

namespace Bank.Aspects
{
    class Payment : AspectBase
    {
        public static double Value = 0;

        public override string Discription { get; set; } = "Payment";
        public override AspectBase Advice { get; set; }

        public Payment(AspectBase advice) : base(advice) { }
        public override void Handeler()
        {
            Console.Write("Much money: ");
            string str = Console.ReadLine();
            if (str.ToLower().Trim() == "end") throw new Exception("End process is successful!");
            Value += Convert.ToDouble(str);
            throw new Model.MessagePack(string.Format("{0} $ is paid successful!\t {1:f2} $ is exist now!", str, Value));
        }
    }
}
