﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Bank.Aspects.Proxy;

namespace Bank.Aspects
{
    class Message : AspectBase
    {
        public override string Discription { get; set; } = "Init";
        public override AspectBase Advice { get; set; }

        public Message(AspectBase advice) : base(advice) { }
        public override void Handeler()
        {
            try
            {
                Advice.Handeler();
            }
            catch (Model.MessagePack ex)
            {
                Discription = "Message[" + ex.Message + "]";
                Console.WriteLine(ex.Message);
            }
            catch (Exception ex)
            {
                Discription = "Error[" + ex.Message + "]";
                Console.WriteLine(ex.Message);
            }
        }
    }
}
