﻿#region Using directives

using System.Runtime.Remoting.Messaging;
using System.Text.RegularExpressions;

#endregion

namespace MiMFa.Libraries.AOPLibrary
{
    public class RegExMethNameMatcher : IMessageMatcher
    {
        private Regex r = null;

        public RegExMethNameMatcher() : this("") {}
        public RegExMethNameMatcher(string filter)
        {r = new Regex(filter);}

        public bool IsMatch(IMessage msg)
        {
            if (msg is IMethodMessage)
                return r.IsMatch(MethodMessageUtil.GetMethodName((IMethodMessage)msg));
            return false;
        }
    }
}
