﻿#region Using directives

using System;
using System.Text;
using System.Windows.Forms;
using System.Runtime.Remoting.Messaging;
using MiMFa.Libraries.AOPLibrary;

#endregion

namespace TestAOP
{
	public class AOPCommutingClass : AOPBaseClass
	{
	}

	public class TestClass : AOPCommutingClass
	{
		private void Output(string s)
		{
			Console.WriteLine(s);
			//MessageBox.Show(s);
		}
        
		public void Test1() { Output("Test1"); }
		public void Test2() { Output("Test2"); }
		public void Test3() { Output("Test3"); }
		public void Go() { Output("Go"); }
	}

	public class TestClassController : AOPBaseController
	{
		private void Output(string s)
		{
			Console.WriteLine(s);
			//MessageBox.Show(s);
		}

		public override void Begin(object o, IMessage msg) { Output("Begin"); }
		public override void End(object o, IMessage msg) { Output("End"); }
	}
}
