﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Bank.Aspects.Proxy;

namespace Bank.Aspects
{
    class Logging : AspectBase
    {
        public override string Discription { get; set; } = "Logging";
        public override AspectBase Advice { get; set; }

        public Logging(AspectBase advice) : base(advice) { }
        public override void Handeler()
        {
            System.IO.File.AppendAllText("LOG.txt",Environment.NewLine+ Advice.Discription + ": "  + " (" + DateTime.Now.Date + DateTime.Now.TimeOfDay + ")",Encoding.UTF8);
            Advice.Handeler();
        }
    }
}
